/*!
 *  omi-touch v0.2.1 by dntzhang
 *  AlloyTouch / Omi integration. Smooth scrolling, rotation, pull to refresh, page transition and any motion for your Omi project.
 *  Github: https://github.com/AlloyTeam/omi
 *  MIT Licensed.
 */

;(function () {
    if(typeof Omi === 'undefined') return

    var OmiTouch = {};
    var AlloyTouch = typeof require === 'function' ? require('alloytouch/alloy_touch.css.js') : window.AlloyTouch;
    var Transform = typeof require === 'function' ? require('css3transform') : window.Transform;


    var noop = function(){

    };

    var getHandler = function(name, dom, instance) {
        var value = dom.getAttribute(name);
        if (value === null) {
            return noop;
        }else{
            return instance[value].bind(instance);
        }
    };

    var getNum = function(name, dom){
        var value = dom.getAttribute(name);
        if(value){
            return parseFloat(value);
        }
    }


    Omi.extendPlugin('omi-touch',function(dom, instance){
        if(dom.alloyTouch) return;
        var target = instance.refs[ dom.getAttribute('motionRef')];
        Transform(target);
        var initialValue = dom.getAttribute('initialValue');
        if(initialValue){
            target[dom.getAttribute('property') || "translateY"] = parseInt(initialValue);
        }

        var alloyTouch = new AlloyTouch({
            touch: dom,//dom
            vertical: dom.getAttribute('vertical') === 'false' ? false : true,//裬Ĭtrueֱtouch
            target: target, //˶Ķ
            property: dom.getAttribute('property') || "translateY",  //˶
            min:  getNum('min', dom), //,˶ԵСֵ
            max:  getNum('max', dom), //,Եֵ
            sensitivity: getNum('sensitivity', dom) ,//,ȣĬֵΪ1Ϊ
            factor: getNum('factor', dom) ,//,ʾλ뱻˶ӳϵĬֵ1
            step: getNum('step', dom),//Уstep
            bindSelf: dom.getAttribute('bindSelf') === 'true' ? true : false,
            change: getHandler('change', dom, instance),
            touchStart: getHandler('touchStart', dom, instance),
            touchMove: getHandler('touchMove', dom, instance),
            touchEnd: getHandler('touchEnd', dom, instance),
            tap: getHandler('tap', dom, instance),
            pressMove: getHandler('pressMove', dom, instance),
            animationEnd: getHandler('animationEnd', dom, instance),
            preventDefault: dom.getAttribute('preventDefault') === 'false' ? false : true
        })

        dom.alloyTouch = alloyTouch
    });


    if (typeof exports == "object") {
        module.exports = OmiTouch;
    } else if (typeof define == "function" && define.amd) {
        define([], function(){ return OmiTouch });
    } else {
        window.OmiTouch = OmiTouch;
    }

})();